# utils.py
import sys
import os

def resource_path(relative_path):
    """获取资源的绝对路径，支持开发和打包环境"""
    try:
        # 如果是打包环境，base_path 是临时目录
        base_path = sys._MEIPASS
        # 获取安装目录
        install_dir = os.path.dirname(sys.executable)
        base_path = install_dir  # 使用安装目录作为基础路径
    except AttributeError:
        # 如果是开发环境，base_path 是项目根目录
        base_path = os.path.abspath(os.path.join(os.path.dirname(__file__), '..', '..'))

    return os.path.join(base_path, relative_path)